import javax.naming.*;
import javax.naming.directory.*;
import java.util.Hashtable;

/**
  * Demonstrates how to look up a matching rule's schema given its name.
  *
  * usage: java LookupMatchingRule
  */
class LookupMatchingRule {
    public static void main(String[] args) {

	// Set up environment for creating initial context
	Hashtable env = new Hashtable(11);
	env.put(Context.INITIAL_CONTEXT_FACTORY, 
	    "com.sun.jndi.ldap.LdapCtxFactory");
	env.put(Context.PROVIDER_URL, "ldap://localhost:389/o=JNDITutorial");

	try {
	    // Create the initial context
	    DirContext ctx = new InitialDirContext(env);

	    // Get the schema tree root
	    DirContext schema = ctx.getSchema("");

	    // Get schema object for matching rule
	    DirContext mrSchema =
		(DirContext)schema.lookup("MatchingRule/caseExactOrderingMatch-en");

	    // Get matching rule schema object's attributes
	    Attributes mrAttrs = mrSchema.getAttributes("");

	    System.out.println(mrAttrs);
	} catch (NamingException e) {
	    e.printStackTrace();
	}
    }
}
