import javax.naming.*;
import javax.naming.directory.*;
import java.util.Hashtable;

/**
  * Demonstrates how to look up an object class's schema given its name.
  *
  * usage: java LookupObjectClass
  */
class LookupObjectClass {
    public static void main(String[] args) {

	// Set up environment for creating initial context
	Hashtable env = new Hashtable(11);
	env.put(Context.INITIAL_CONTEXT_FACTORY, 
	    "com.sun.jndi.ldap.LdapCtxFactory");
	env.put(Context.PROVIDER_URL, "ldap://localhost:389/o=JNDITutorial");

	try {
	    // Create the initial context
	    DirContext ctx = new InitialDirContext(env);

	    // Get the schema tree root
	    DirContext schema = ctx.getSchema("");

	    // Get schema object for "person"
	    DirContext personSchema =
		(DirContext)schema.lookup("ClassDefinition/person");

	    // Get "person" object's attributes
	    Attributes personAttrs = personSchema.getAttributes("");

	    System.out.println(personAttrs);
	} catch (NamingException e) {
	    e.printStackTrace();
	}
    }
}
