import javax.naming.*;
import java.util.Hashtable;
import java.rmi.*;

/**
  * Demonstrates how to read a Remote object from a directory.
  *
  * Registry must be running, and RemoteObj from the Storing
  * lesson must be running.
  *
  * 1.2: java -Djava.security.policy=.policy -Djava.security.manager LookupRemote
  * 1.1: java LookupRemote
  */
class LookupRemote {
    public static void main(String[] args) {
	// Set up environment for creating initial context
	Hashtable env = new Hashtable(11);
	env.put(Context.INITIAL_CONTEXT_FACTORY, 
	    "com.sun.jndi.ldap.LdapCtxFactory");
	env.put(Context.PROVIDER_URL, "ldap://localhost:389/o=JNDITutorial");

	try {
	    // Create the initial context
	    Context ctx = new InitialContext(env);

	    // Read from directory 
	    Hello h = (Hello)ctx.lookup("cn=Hello");

	    // Execute remote method
	    System.out.println(h.sayHello());

	} catch (NamingException e) {
	    System.out.println("Operation failed: " + e);
	} catch (RemoteException e) {
	    System.out.println("Operation failed: " + e);
	}
    }
}
